/*
 * Copyright (C) 1996 Emanuel Borsboom <manny@zerius.victoria.bc.ca>
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

package sound.zrs.synthgen;

public abstract class Generator {

    boolean recalculateFlag = true;
    double value;

    Synthesizer parent;

    public Generator(Synthesizer parent) {
        this.parent = parent;
    }

    void recalculate() {
        recalculateFlag = true;
    }

    double getValue() throws SynthesizerException {
        if (recalculateFlag) {
            recalculateFlag = false; // setting it here eliminates infinite recursion
            value = nextValue();
        }
        return value;
    }

    abstract double nextValue() throws SynthesizerException;
}
